<template>
    <div class="login-box">
        <div class="login-logo center">
            <img src="https://cdn2.iconfinder.com/data/icons/building-219/66/2-512.png" style="margin: 0 auto;" height="170">
        </div>
        <!-- /.login-logo -->
        <div class="card">
            <div class="card-body login-card-body">
                
                <p class="login-box-msg">Ingresa tus credenciales para Iniciar Sesión</p>

                <form method="post">
                    <div class="input-group mb-3">
                        <input @keyup.enter="login" v-model="fillLogin.cEmail" type="email" class="form-control" placeholder="Email">
                        <div class="input-group-append">
                            <div class="input-group-text">
                                <span class="fas fa-envelope"></span>
                            </div>
                        </div>
                    </div>
                    <div class="input-group mb-3">
                        <input @keyup.enter="login" v-model="fillLogin.cPassword" type="password" class="form-control" placeholder="Contraseña">
                        <div class="input-group-append">
                            <div class="input-group-text">
                                <span class="fas fa-lock"></span>
                            </div>
                        </div>
                    </div>
                </form>

                <div class="row">
                    <div class="col-12">
                        <span v-if="error">
                            <div v-for="(e, index) in mensajeError" :key="index" v-text="e" class="callout callout-danger"></div>
                        </span>
                    </div>
                </div>

                <div class="social-auth-links text-center mb-3">
                    <button class="btn btn-flat btn-primary" @click.prevent="login" v-loading.fullscreen.lock="fullscreenLoading">
                        Iniciar Sesión
                    </button>  
                </div>
                <!-- /.social-auth-links -->

                <!-- <p class="mb-1">
                    <a href="/resetPassword">Recordar contraseña</a>
                </p> -->
            </div>
            <!-- /.login-card-body -->
        </div>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                fillLogin: {
                    cEmail: '',
                    cPassword: ''
                },
                fullscreenLoading: false,
                error: 0,
                mensajeError: []
            }
        },
        methods: {          
            login() {
                if(this.validarLogin()) {
                    return;
                }

                this.fullscreenLoading = true;
                axios.post('/login', {
                    'cEmail' : this.fillLogin.cEmail,
                    'cPassword' : this.fillLogin.cPassword,                    
                }).then(response=> {
                    console.log(response);
                    if(response.data.code == 401) {
                        this.loginFailed();
                    }
                    if(response.data.code == 200) {                        
                        sessionStorage.setItem('authUser', JSON.stringify(response.data.authUser));
                        this.loginSuccess();
                    }              
                    if(response.data.code == 202){
                        sessionStorage.setItem('authUser', JSON.stringify(response.data.authUser));
                        this.restorePassword();
                    }
                });
            },
            validarLogin() {
                this.error = 0;
                this.mensajeError = [];

                if(!this.fillLogin.cEmail) {
                    this.mensajeError.push('El correo electrónico es un campo obligatorio');
                }

                if(!this.fillLogin.cPassword) {
                    this.mensajeError.push('La contraseña es un campo obligatorio');
                }

                if(this.mensajeError.length) {
                    this.error = 1;
                }

                return this.error;
            },
            loginFailed() {
                this.fullscreenLoading = false;
                this.error = 0;
                this.mensajeError = []; 

                this.mensajeError.push('Estas credenciales no coinciden con nuestros registros.');

                this.fillLogin.cEmail = '';
                this.fillLogin.cPassword = '';

                if(this.mensajeError.length) {
                    this.error = 1;
                }

                return this.error;
            }, 
            restorePassword() {
               // this.$router.push({ name: 'dashboard.index' });
                window.location.href = '/restorePassword';
                //location.reload();
                setTimeout(()=>{
                    this.fullscreenLoading = false;
                },1800)
            }, 
            loginSuccess() {
                //this.$router.push({ name: 'dashboard.index' });
                window.location.href = '/dashboard';
                //location.reload();
                setTimeout(()=>{
                    this.fullscreenLoading = false;
                },1800)
            }
        }
    }
</script>

<style>

</style>